Imports System


Namespace Utility



    'CustomSessionHandler handles saving and retriving Items from Session in a coherant and 
    'Managable Manner.
    'To use it you ust first add the Items you want save to save to Session in the PRToolSessionItems Enum
    'declared at the bottom of this class. Once the Item is added you can use it with this Class
    Public NotInheritable Class CustomSessionHandler

#Region "Private Fields"

        Private InsideSession As System.Web.SessionState.HttpSessionState = System.Web.HttpContext.Current.Session

        'Hashtable to Store Application Level Items
        Private SessionItems As Hashtable

#End Region

#Region "Private Methods"

        Private Sub UpdateSession(Optional ByVal Access As Integer = 1)
            If Access = 1 Then Me.InsideSession.Item("theSessionItems") = Me.SessionItems 'Save
            If Access <> 1 Then
                If IsNothing(Me.InsideSession.Item("theSessionItems")) Then
                    Me.SessionItems = New Hashtable
                Else
                    Me.SessionItems = CType(Me.InsideSession.Item("theSessionItems"), Hashtable)
                End If
            End If
        End Sub

        Private Sub RemoveItem(ByVal KeyName As ItemsInSession)
            Me.SessionItems.Remove(KeyName)
            Me.UpdateSession()
        End Sub

#End Region

#Region "Constructors"

        Public Sub New()
        End Sub

#End Region

#Region "Public Methods & Properties"

        Public Sub SetItem(ByVal KeyName As ItemsInSession, ByVal Item As Object)
            Me.UpdateSession(0)
            Me.RemoveItem(KeyName)
            Me.SessionItems.Add(KeyName, Item)
            Me.UpdateSession()
        End Sub

        Public Function Item(ByVal KeyName As ItemsInSession) As Object
            'Me.UpdateSession(0)
            Return Me.SessionItems(KeyName)
        End Function

        Public ReadOnly Property SessionID() As String
            Get
                Return Me.InsideSession.SessionID
            End Get
        End Property

        Public ReadOnly Property GetAllValues() As String
            Get
                Me.UpdateSession(0)
                Dim obj As Object
                Dim i As Integer = 0
                Dim rStr As String

                For Each obj In Me.SessionItems.Keys
                    rStr &= "Key Name:-> " & obj.ToString() & " Value:->" & Me.SessionItems.Item(obj).ToString & "<br>"
                Next
                Return rStr
            End Get
        End Property

#End Region

    End Class


#Region "Session Items :- Add Your Session Items Here, before using the CustomSessionHandlerClass"

    Public Enum ItemsInSession
        ErrorMessage
        CurrentEventID
        CurrentUserID
        CurrentCalID
        'Add More Key Names Here Depending on what you need to keep in Session
    End Enum

#End Region



End Namespace