Imports System.IO


Namespace Utility

    Public Class ImageUtility

#Region "Shared Function For Image Resizing"
        Public Shared Function ResizeImage(ByVal ImgPath As String, ByVal NewWidth As Integer) As System.Drawing.Size

            Dim retSize As System.Drawing.Size
            retSize.Width = 0
            retSize.Height = 0

            Try
                'Display the Picture and try to maintain an Aspect Ratio of 1
                If ImgPath.Length > 0 Then

                    'Try to Resize to Picture if its not big
                    Dim fullSizeImg As System.Drawing.Image
                    Dim fs As New System.IO.FileStream(System.Web.HttpContext.Current.Server.MapPath("~/" & ImgPath), IO.FileMode.Open)
                    fullSizeImg = System.Drawing.Image.FromStream(fs)

                    Dim mag As Integer
                    'Compute Magnifaction
                    mag = fullSizeImg.Width / fullSizeImg.Height

                    If fullSizeImg.Width > NewWidth Then
                        retSize.Width = NewWidth
                        retSize.Height = (NewWidth / mag)
                    Else
                        retSize.Width = fullSizeImg.Width
                        retSize.Height = fullSizeImg.Height
                    End If

                    fullSizeImg.Dispose()
                    fs.Close()

                End If
            Catch ex As Exception
                Throw ex
                'Trace.Write("Image Display Error ", ex.Message)
            End Try

            Return retSize
        End Function
#End Region

#Region "Sahed Function For Deleting images"

        Public Shared Function DeletePicture(ByVal PicturePath As String)

            Try

                If System.IO.File.Exists(System.Web.HttpContext.Current.Server.MapPath("~/" & PicturePath)) Then
                    System.IO.File.Delete(System.Web.HttpContext.Current.Server.MapPath("~/" & PicturePath))
                End If

            Catch ex As Exception
            End Try

        End Function
#End Region

    End Class

End Namespace