Imports System
Imports System.Web
Imports WMail = System.Web.Mail
Imports System.Text.RegularExpressions


Namespace Utility


    Public Class MailMgr

#Region "Private Members"

        Private m_Mailer As New WMail.MailMessage
        Private m_MailBody As String
        Private m_MailSubject As String
        Private m_MailTo As String
        Private m_MailMessage As String
        Private m_MailName As String
        Private m_MailSenderAddress As String
        Private m_SMTPServer As String
        Private oneEmailAddress As String

        Private EmailExpressionChecker As New Regex("\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*")

#End Region

#Region "Public Properties"

        Public Property MessageBody() As String
            Get
                Return Me.m_MailBody
            End Get
            Set(ByVal Value As String)
                Me.m_MailBody = Value
            End Set
        End Property

        Public Property MessageSubject() As String
            Get
                Return Me.m_MailSubject
            End Get
            Set(ByVal Value As String)
                Me.m_MailSubject = Value
            End Set
        End Property

        Public Property MessageRecipiants() As String
            Get
                Return Me.m_MailTo
            End Get
            Set(ByVal Value As String)

                'Since Recipiants can be comma delimited check that each of the email address is valid
                'Slipt the email address list sent it and check the email address.
                For Each Me.oneEmailAddress In Value.Split(New Char() {";"c})
                    If Not Me.EmailExpressionChecker.IsMatch(Me.oneEmailAddress) Then
                        Throw New Exception("The email address '" & Me.oneEmailAddress & "' is invalid")
                    End If
                Next Me.oneEmailAddress

                Me.m_MailTo = Value

            End Set

        End Property

#End Region

#Region "Constructors"

        Sub New(ByVal MailerName As String, ByVal SenderEmail As String, ByVal ServerSMTP As String)
            If (Len(MailerName) > 0) And (Len(ServerSMTP) > 0) And (Len(SenderEmail) > 0) Then
                Me.m_MailName = MailerName
                Me.m_SMTPServer = ServerSMTP
                Me.m_MailSenderAddress = SenderEmail
            Else
                Throw New Exception("You must Provide a name for the Mail Manager, a valid Sender email address, and a SMTP Server Address")
            End If
        End Sub

#End Region

#Region "Supporting Functions"

        Public Sub SendMail()
            Me.m_Mailer.From = Me.m_MailName & "<" & Me.m_MailSenderAddress & ">"
            Me.m_Mailer.To = Me.m_MailTo
            Me.m_Mailer.Subject = Me.m_MailSubject
            Me.m_Mailer.Body = Me.m_MailBody
            Me.m_Mailer.BodyFormat = WMail.MailFormat.Html

            WMail.SmtpMail.SmtpServer = Me.m_SMTPServer
            WMail.SmtpMail.Send(Me.m_Mailer)

        End Sub



#End Region

    End Class

End Namespace