Imports System.Web
Imports System.Web.Mail
Imports System.Web.Security
Imports System.Data.SqlClient
Imports System.Security.Principal
Imports System.Web.SessionState
Imports OVBiz = OverSight.Business

Public Class Global
    Inherits System.Web.HttpApplication

    Private HiddenSessionHandler As OVBiz.Utility.CustomSessionHandler = Nothing

#Region " Component Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Component Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Required by the Component Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Component Designer
    'It can be modified using the Component Designer.
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
    End Sub

#End Region

#Region "Application Start"
    Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires when the application is started
        Application("UserCount") = 0
    End Sub
#End Region

#Region "Session Start"
    Sub Session_Start(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires when the session is started

        'Keep Track of How Many Users are Logged On
        Application("UserCount") = CInt(Application("UserCount")) + 1

        'Create a New Custom Session Handler
        Me.HiddenSessionHandler = New OVBiz.Utility.CustomSessionHandler

        'Then Save this Hidden Session Haanlde to the Session
        'Each Time the a Programmer tries to access a Variable in sesssion,
        'the shared Global.PRToolSession() Function will be used to retrieve this Object
        Session.Add("OverSightCustomHandler", Me.HiddenSessionHandler)

    End Sub
#End Region

#Region "Application Begin Request"
    Sub Application_BeginRequest(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires at the beginning of each request
    End Sub
#End Region

#Region "Application Authenticate Request"
    Sub Application_AuthenticateRequest(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires upon attempting to authenticate the use
    End Sub
#End Region

#Region "Application Error"
    Sub Application_Error(ByVal sender As Object, ByVal e As EventArgs)

        If TypeOf Me.Server.GetLastError Is HttpRequestValidationException Then
            Response.Redirect("~/Common/DefaultErrorMessage.aspx?BadInput=1")
        End If

        If OVBiz.Utility.ConfigurationHandler.CurrentConfig = "Production" Then

            OVBiz.Utility.ErrorHandler.RaiseError(Me.Server.GetLastError, OVBiz.Utility.ConfigurationHandler.EmailServerAddress)
            Server.Transfer(OVBiz.Utility.ConfigurationHandler.ErrorRedirectPage)

        ElseIf OVBiz.Utility.ConfigurationHandler.CurrentConfig = "Development" Then

            Dim ErrMsg As String
            ErrMsg = OVBiz.Utility.ErrorHandler.RaiseError(Me.Server.GetLastError, OVBiz.Utility.ConfigurationHandler.EmailServerAddress)

            Global.OVSession.SetItem(OVBiz.Utility.ItemsInSession.ErrorMessage, ErrMsg)
            Server.Transfer(OVBiz.Utility.ConfigurationHandler.ErrorRedirectPage)

        End If

    End Sub
#End Region

#Region "Session End"
    Sub Session_End(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires when the session ends

        'Keep Track of How Many Users are Logged On
        Application("UserCount") = CInt(Application("UserCount")) - 1
    End Sub
#End Region

#Region "Application End"
    Sub Application_End(ByVal sender As Object, ByVal e As EventArgs)
        ' Fires when the application ends
    End Sub
#End Region

#Region "Shared Function:- Session Accessor"
    Public Shared Function OVSession() As OVBiz.Utility.CustomSessionHandler
        Return CType(System.Web.HttpContext.Current.Session.Item("OverSightCustomHandler"), OVBiz.Utility.CustomSessionHandler)
    End Function
#End Region

#Region "Gloabl Aquire Request State Used for security"
    Private Sub Global_AcquireRequestState(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.AcquireRequestState

        ' set the security principal to our BusinessPrincipal
        If Not Session("CustomPrincipal") Is Nothing Then
            System.Threading.Thread.CurrentPrincipal = Session("CustomPrincipal")
            HttpContext.Current.User = Session("CustomPrincipal")

        Else
            If System.Threading.Thread.CurrentPrincipal.Identity.IsAuthenticated Then
                Web.Security.FormsAuthentication.SignOut()
                Server.Transfer("~/Common/UserLogin.aspx")
            End If
        End If

    End Sub
#End Region

End Class
